/*
Copyright (C) 2012 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.net.DatagramSocket;

class Client implements Runnable {

  ClientMulticast clientMulticast;
  private Snapshot snapshot;
  private BaseCanvas baseCanvas;
  private TcpClient tcpClient;
  private boolean sendImageLoopFlag = false;
  private DatagramSocket dsCheckDummy;

  public Client(Snapshot _snapshot) throws Exception{
    try{
      snapshot = _snapshot;
      try{
        // dsCheckDummy =  new DatagramSocket(snapshot.ini.getUnicastPortForClient());
      }catch(Exception e){
        C.error("Client: Client: ɋNĂ܂B" + e.toString());
        C.exit();
      }
      baseCanvas = new BaseCanvas(snapshot);
      clientMulticast = new ClientMulticast(snapshot);
      tcpClient = new TcpClient(snapshot);
    }catch(Exception e){
      C.throwException("Client: Client:", e);
    }
  }

  public BaseCanvas getBaseCanvas(){ return baseCanvas; }

  public void cancelImage(){
    sendImageLoopFlag = false;
  }

  public void sendImage(){
    if(sendImageLoopFlag)
      return;
    sendImageLoopFlag = true;
    new Thread(this).start();
  }

  public void run(){
    try{
      while(sendImageLoopFlag){
        sendImageInThread();
      }
    }catch(Exception e){
      C.log("Client: run:" + C.cr + e.toString());
    }
  }

  void sendImageInThread(){
    try{
      snapshot.capture();
      clientMulticast.sendImage(ClientMulticast.CLIENT_SEND_IMAGE, snapshot.captureImage);
    }catch(Exception e){
      C.error("Client: sendImage:" + C.cr + e.toString());
    }
  }

}
